package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.resource.Agent;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface AgentGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AgentGWTService
     */
    void getAgentForResource( int resourceId, AsyncCallback<org.rhq.core.domain.resource.Agent> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AgentGWTService
     */
    void pingAgentForResource( int resourceId, AsyncCallback<java.lang.Boolean> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static AgentGWTServiceAsync instance;

        public static final AgentGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (AgentGWTServiceAsync) GWT.create( AgentGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "AgentGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
