package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.ArrayList;
import java.util.HashMap;
import org.rhq.core.domain.bundle.Bundle;
import org.rhq.core.domain.bundle.BundleDeployment;
import org.rhq.core.domain.bundle.BundleDestination;
import org.rhq.core.domain.bundle.BundleFile;
import org.rhq.core.domain.bundle.BundleResourceDeployment;
import org.rhq.core.domain.bundle.BundleType;
import org.rhq.core.domain.bundle.BundleVersion;
import org.rhq.core.domain.bundle.ResourceTypeBundleConfiguration;
import org.rhq.core.domain.bundle.composite.BundleWithLatestVersionComposite;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.criteria.BundleCriteria;
import org.rhq.core.domain.criteria.BundleDeploymentCriteria;
import org.rhq.core.domain.criteria.BundleDestinationCriteria;
import org.rhq.core.domain.criteria.BundleFileCriteria;
import org.rhq.core.domain.criteria.BundleResourceDeploymentCriteria;
import org.rhq.core.domain.criteria.BundleVersionCriteria;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface BundleGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void getResourceTypeBundleConfiguration( int compatGroupId, AsyncCallback<org.rhq.core.domain.bundle.ResourceTypeBundleConfiguration> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void createBundleVersion( int bundleId, java.lang.String name, java.lang.String version, java.lang.String recipe, AsyncCallback<org.rhq.core.domain.bundle.BundleVersion> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void createBundleVersionViaURL( java.lang.String url, AsyncCallback<org.rhq.core.domain.bundle.BundleVersion> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void createBundleVersionViaRecipe( java.lang.String recipe, AsyncCallback<org.rhq.core.domain.bundle.BundleVersion> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void createBundleDeployment( int bundleVersionId, int bundleDestinationId, java.lang.String description, org.rhq.core.domain.configuration.Configuration configuration, boolean enforcePolicy, int enforcementInterval, boolean pinToBundle, AsyncCallback<org.rhq.core.domain.bundle.BundleDeployment> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void createBundleDestination( int bundleId, java.lang.String name, java.lang.String description, java.lang.String destBaseDirName, java.lang.String deployDir, int groupId, AsyncCallback<org.rhq.core.domain.bundle.BundleDestination> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void deleteBundles( int[] bundleIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void deleteBundle( int bundleId, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void deleteBundleDeployment( int bundleDeploymentId, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void deleteBundleDestination( int bundleDestinationId, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void deleteBundleVersion( int bundleVersionId, boolean deleteBundleIfEmpty, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundlesByCriteria( org.rhq.core.domain.criteria.BundleCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.Bundle>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundlesByCriteriaWithDestinationFilter( org.rhq.core.domain.criteria.BundleCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.Bundle>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundleDeploymentsByCriteria( org.rhq.core.domain.criteria.BundleDeploymentCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.BundleDeployment>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundleDeploymentsByCriteriaWithDestinationFilter( org.rhq.core.domain.criteria.BundleDeploymentCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.BundleDeployment>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundleDestinationsByCriteria( org.rhq.core.domain.criteria.BundleDestinationCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.BundleDestination>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundleFilesByCriteria( org.rhq.core.domain.criteria.BundleFileCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.BundleFile>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundleResourceDeploymentsByCriteria( org.rhq.core.domain.criteria.BundleResourceDeploymentCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.BundleResourceDeployment>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundleVersionsByCriteria( org.rhq.core.domain.criteria.BundleVersionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.BundleVersion>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundleVersionsByCriteriaWithDestinationFilter( org.rhq.core.domain.criteria.BundleVersionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.BundleVersion>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void findBundlesWithLatestVersionCompositesByCriteria( org.rhq.core.domain.criteria.BundleCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.bundle.composite.BundleWithLatestVersionComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void getAllBundleVersionFilenames( int bundleVersionId, AsyncCallback<java.util.HashMap<java.lang.String,java.lang.Boolean>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void getAllBundleTypes( AsyncCallback<java.util.ArrayList<org.rhq.core.domain.bundle.BundleType>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void getBundleDeploymentName( int bundleDestinationId, int bundleVersionId, int prevDeploymentId, AsyncCallback<java.lang.String> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void scheduleBundleDeployment( int bundleDeploymentId, boolean isCleanDeployment, AsyncCallback<org.rhq.core.domain.bundle.BundleDeployment> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void scheduleRevertBundleDeployment( int bundleDestinationId, java.lang.String deploymentDescription, boolean isCleanDeployment, AsyncCallback<org.rhq.core.domain.bundle.BundleDeployment> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.BundleGWTService
     */
    void purgeBundleDestination( int bundleDestinationId, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static BundleGWTServiceAsync instance;

        public static final BundleGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (BundleGWTServiceAsync) GWT.create( BundleGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "BundleGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
