package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.common.EntityContext;
import org.rhq.core.domain.criteria.DriftDefinitionCriteria;
import org.rhq.core.domain.criteria.DriftDefinitionTemplateCriteria;
import org.rhq.core.domain.criteria.GenericDriftChangeSetCriteria;
import org.rhq.core.domain.criteria.GenericDriftCriteria;
import org.rhq.core.domain.drift.Drift;
import org.rhq.core.domain.drift.DriftChangeSet;
import org.rhq.core.domain.drift.DriftComposite;
import org.rhq.core.domain.drift.DriftDefinition;
import org.rhq.core.domain.drift.DriftDefinitionComposite;
import org.rhq.core.domain.drift.DriftDefinitionTemplate;
import org.rhq.core.domain.drift.DriftDetails;
import org.rhq.core.domain.drift.DriftSnapshot;
import org.rhq.core.domain.drift.DriftSnapshotRequest;
import org.rhq.core.domain.drift.FileDiffReport;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface DriftGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void createTemplate( int resourceTypeId, org.rhq.core.domain.drift.DriftDefinition definition, AsyncCallback<org.rhq.core.domain.drift.DriftDefinitionTemplate> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void deleteDriftDefinitionsByContext( org.rhq.core.domain.common.EntityContext entityContext, java.lang.String[] driftDefNames, AsyncCallback<java.lang.Integer> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void detectDrift( org.rhq.core.domain.common.EntityContext entityContext, org.rhq.core.domain.drift.DriftDefinition driftDef, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void findDriftChangeSetsByCriteria( org.rhq.core.domain.criteria.GenericDriftChangeSetCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<? extends org.rhq.core.domain.drift.DriftChangeSet>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void findDriftCompositesByCriteria( org.rhq.core.domain.criteria.GenericDriftCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.drift.DriftComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void findDriftDefinitionCompositesByCriteria( org.rhq.core.domain.criteria.DriftDefinitionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.drift.DriftDefinitionComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void findDriftDefinitionsByCriteria( org.rhq.core.domain.criteria.DriftDefinitionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.drift.DriftDefinition>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void findDriftDefinitionTemplatesByCriteria( org.rhq.core.domain.criteria.DriftDefinitionTemplateCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.drift.DriftDefinitionTemplate>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void findDriftsByCriteria( org.rhq.core.domain.criteria.GenericDriftCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<? extends org.rhq.core.domain.drift.Drift>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void getDriftDefinition( int driftDefId, AsyncCallback<org.rhq.core.domain.drift.DriftDefinition> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void getDriftDetails( java.lang.String driftId, AsyncCallback<org.rhq.core.domain.drift.DriftDetails> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void getDriftFileBits( java.lang.String hash, AsyncCallback<java.lang.String> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void getSnapshot( org.rhq.core.domain.drift.DriftSnapshotRequest request, AsyncCallback<org.rhq.core.domain.drift.DriftSnapshot> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void generateUnifiedDiff( org.rhq.core.domain.drift.Drift<?,?> drift, AsyncCallback<org.rhq.core.domain.drift.FileDiffReport> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void generateUnifiedDiffByIds( java.lang.String driftId1, java.lang.String driftId2, AsyncCallback<org.rhq.core.domain.drift.FileDiffReport> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void isBinaryFile( org.rhq.core.domain.drift.Drift<?,?> drift, AsyncCallback<java.lang.Boolean> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void pinSnapshot( int driftDefId, int version, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void pinTemplate( int templateId, int snapshotDriftDefId, int snapshotVersion, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DriftGWTService
     */
    void updateDriftDefinition( org.rhq.core.domain.common.EntityContext entityContext, org.rhq.core.domain.drift.DriftDefinition driftDef, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static DriftGWTServiceAsync instance;

        public static final DriftGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (DriftGWTServiceAsync) GWT.create( DriftGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "DriftGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
