package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.List;
import java.util.Set;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;
import org.rhq.core.domain.common.EntityContext;
import org.rhq.core.domain.criteria.MeasurementDataTraitCriteria;
import org.rhq.core.domain.criteria.MeasurementDefinitionCriteria;
import org.rhq.core.domain.criteria.MeasurementScheduleCriteria;
import org.rhq.core.domain.measurement.DisplayType;
import org.rhq.core.domain.measurement.MeasurementData;
import org.rhq.core.domain.measurement.MeasurementDataTrait;
import org.rhq.core.domain.measurement.MeasurementDefinition;
import org.rhq.core.domain.measurement.MeasurementSchedule;
import org.rhq.core.domain.measurement.calltime.CallTimeDataComposite;
import org.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite;
import org.rhq.core.domain.measurement.composite.MeasurementOOBComposite;
import org.rhq.core.domain.measurement.composite.MeasurementScheduleComposite;
import org.rhq.core.domain.util.PageControl;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface MeasurementDataGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findCurrentTraitsForResource( int resourceId, org.rhq.core.domain.measurement.DisplayType displayType, AsyncCallback<java.util.List<org.rhq.core.domain.measurement.MeasurementDataTrait>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findLiveData( int resourceId, int[] definitionIds, AsyncCallback<java.util.Set<org.rhq.core.domain.measurement.MeasurementData>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findDataForResource( int resourceId, int[] definitionIds, long beginTime, long endTime, int numPoints, AsyncCallback<java.util.List<java.util.List<org.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite>>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findDataForCompatibleGroup( int groupId, int[] definitionIds, long beginTime, long endTime, int numPoints, AsyncCallback<java.util.List<java.util.List<org.rhq.core.domain.measurement.composite.MeasurementDataNumericHighLowComposite>>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findCallTimeDataForResource( int scheduleId, long start, long end, org.rhq.core.domain.util.PageControl pageControl, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.calltime.CallTimeDataComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findMeasurementDefinitionsByCriteria( org.rhq.core.domain.criteria.MeasurementDefinitionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.MeasurementDefinition>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findMeasurementSchedulesByCriteria( org.rhq.core.domain.criteria.MeasurementScheduleCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.MeasurementSchedule>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void getMeasurementScheduleCompositesByContext( org.rhq.core.domain.common.EntityContext context, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.composite.MeasurementScheduleComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void getSchedulesWithOOBs( java.lang.String metricNameFilter, java.lang.String resourceNameFilter, java.lang.String parentNameFilter, org.rhq.core.domain.util.PageControl pc, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.composite.MeasurementOOBComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void getHighestNOOBsForResource( int resourceId, int n, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.composite.MeasurementOOBComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void getHighestNOOBsForGroup( int groupId, int n, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.composite.MeasurementOOBComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void enableSchedulesForResource( int resourceId, int[] measurementDefinitionIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void disableSchedulesForResource( int resourceId, int[] measurementDefinitionIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void updateSchedulesForResource( int resourceId, int[] measurementDefinitionIds, long collectionInterval, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void enableSchedulesForCompatibleGroup( int resourceGroupId, int[] measurementDefinitionIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void disableSchedulesForCompatibleGroup( int resourceGroupId, int[] measurementDefinitionIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void updateSchedulesForCompatibleGroup( int resourceGroupId, int[] measurementDefinitionIds, long collectionInterval, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void enableSchedulesForResourceType( int[] measurementDefinitionIds, boolean updateExistingSchedules, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void disableSchedulesForResourceType( int[] measurementDefinitionIds, boolean updateExistingSchedules, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void updateSchedulesForResourceType( int[] measurementDefinitionIds, long collectionInterval, boolean updateExistingSchedules, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.MeasurementDataGWTService
     */
    void findTraitsByCriteria( org.rhq.core.domain.criteria.MeasurementDataTraitCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.MeasurementDataTrait>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static MeasurementDataGWTServiceAsync instance;

        public static final MeasurementDataGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (MeasurementDataGWTServiceAsync) GWT.create( MeasurementDataGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "MeasurementDataGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
