package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.ArrayList;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.configuration.definition.ConfigurationDefinition;
import org.rhq.core.domain.plugin.Plugin;
import org.rhq.core.domain.plugin.PluginKey;
import org.rhq.core.domain.plugin.ServerPlugin;
import org.rhq.core.domain.plugin.ServerPluginControlDefinition;
import org.rhq.core.domain.plugin.ServerPluginControlResults;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface PluginGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void restartMasterPluginContainer( AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void getAgentPlugin( int pluginId, AsyncCallback<org.rhq.core.domain.plugin.Plugin> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void getServerPlugin( int pluginId, boolean includeRelationships, AsyncCallback<org.rhq.core.domain.plugin.ServerPlugin> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void getAgentPlugins( boolean includeDeletedPlugins, AsyncCallback<java.util.ArrayList<org.rhq.core.domain.plugin.Plugin>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void getServerPlugins( boolean includeDeletedPlugins, AsyncCallback<java.util.ArrayList<org.rhq.core.domain.plugin.ServerPlugin>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void scanAndRegister( AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void enableAgentPlugins( int[] selectedPluginIds, AsyncCallback<java.util.ArrayList<java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void disableAgentPlugins( int[] selectedPluginIds, AsyncCallback<java.util.ArrayList<java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void deleteAgentPlugins( int[] selectedPluginIds, AsyncCallback<java.util.ArrayList<java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void purgeAgentPlugins( int[] selectedPluginIds, AsyncCallback<java.util.ArrayList<java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void enableServerPlugins( int[] selectedPluginIds, AsyncCallback<java.util.ArrayList<java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void disableServerPlugins( int[] selectedPluginIds, AsyncCallback<java.util.ArrayList<java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void undeployServerPlugins( int[] selectedPluginIds, AsyncCallback<java.util.ArrayList<java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void purgeServerPlugins( int[] selectedPluginIds, AsyncCallback<java.util.ArrayList<java.lang.String>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void getServerPluginConfigurationDefinition( org.rhq.core.domain.plugin.PluginKey pluginKey, AsyncCallback<org.rhq.core.domain.configuration.definition.ConfigurationDefinition> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void getServerPluginScheduledJobsDefinition( org.rhq.core.domain.plugin.PluginKey pluginKey, AsyncCallback<org.rhq.core.domain.configuration.definition.ConfigurationDefinition> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void getServerPluginControlDefinitions( org.rhq.core.domain.plugin.PluginKey serverPluginKey, AsyncCallback<java.util.ArrayList<org.rhq.core.domain.plugin.ServerPluginControlDefinition>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void invokeServerPluginControl( org.rhq.core.domain.plugin.PluginKey serverPluginKey, java.lang.String controlName, org.rhq.core.domain.configuration.Configuration params, AsyncCallback<org.rhq.core.domain.plugin.ServerPluginControlResults> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void updateServerPluginConfiguration( org.rhq.core.domain.plugin.PluginKey serverPluginKey, org.rhq.core.domain.configuration.Configuration config, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.PluginGWTService
     */
    void updateServerPluginScheduledJobs( org.rhq.core.domain.plugin.PluginKey serverPluginKey, org.rhq.core.domain.configuration.Configuration jobsConfig, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static PluginGWTServiceAsync instance;

        public static final PluginGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (PluginGWTServiceAsync) GWT.create( PluginGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "PluginGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
