package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.install.remote.AgentInstallInfo;
import org.rhq.core.domain.install.remote.RemoteAccessInfo;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface RemoteInstallGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService
     */
    void agentInstallCheck( org.rhq.core.domain.install.remote.RemoteAccessInfo remoteAccessInfo, java.lang.String agentInstallPath, AsyncCallback<java.lang.Boolean> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService
     */
    void installAgent( org.rhq.core.domain.install.remote.RemoteAccessInfo remoteAccessInfo, java.lang.String parentPath, AsyncCallback<org.rhq.core.domain.install.remote.AgentInstallInfo> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService
     */
    void startAgent( org.rhq.core.domain.install.remote.RemoteAccessInfo remoteAccessInfo, java.lang.String agentInstallPath, AsyncCallback<java.lang.String> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService
     */
    void stopAgent( org.rhq.core.domain.install.remote.RemoteAccessInfo remoteAccessInfo, java.lang.String agentInstallPath, AsyncCallback<java.lang.String> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService
     */
    void agentStatus( org.rhq.core.domain.install.remote.RemoteAccessInfo remoteAccessInfo, java.lang.String agentInstallPath, AsyncCallback<java.lang.String> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService
     */
    void findAgentInstallPath( org.rhq.core.domain.install.remote.RemoteAccessInfo remoteAccessInfo, java.lang.String parentPath, AsyncCallback<java.lang.String> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RemoteInstallGWTService
     */
    void remotePathDiscover( org.rhq.core.domain.install.remote.RemoteAccessInfo remoteAccessInfo, java.lang.String parentPath, AsyncCallback<java.lang.String[]> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static RemoteInstallGWTServiceAsync instance;

        public static final RemoteInstallGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (RemoteInstallGWTServiceAsync) GWT.create( RemoteInstallGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "RemoteInstallGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
